#!/usr/bin/env python

# Copyright (C) 2015 Canonical
# All Rights Reserved
# Author: Jill Rouleau <jill.rouleau@canonical.com>
#
# Check a running MySQL instance to see if it's running hot on used connections

import MySQLdb
import argparse
import sys
import socket

hostname = socket.gethostname()
db = MySQLdb.connect(host='localhost', user='debian-sys-maint', passwd='0308NGsnQlrPaiso')
c = db.cursor()


class CheckMysql:
    c.execute("SHOW STATUS LIKE 'threads_connected';")
    result = c.fetchone()
    threads = result[1]

    c.execute("SHOW GLOBAL VARIABLES LIKE 'max_connections';")
    result = c.fetchone()
    maxconns = result[1]

percent_used = round(((float(CheckMysql.threads) / float(CheckMysql.maxconns)) * 100), 2)

parser = argparse.ArgumentParser()
parser.add_argument('-w', action="store", dest="warn", type=int)
parser.add_argument('-c', action="store", dest="crit", type=int)
args = parser.parse_args()

if percent_used < args.warn:
    print("OK - {} is using {} percent of it's {} available connections".format
          (hostname, percent_used, CheckMysql.maxconns)),
    sys.exit(0)
elif percent_used >= args.warn and percent_used < args.crit:
    print("{} is using {} out of {} available connections, {} percent".format
          (hostname, CheckMysql.threads, CheckMysql.maxconns, percent_used)),
    sys.exit(1)
elif percent_used >= args.crit:
    print("{} is using {} out of {} available connections, {} percent".format
          (hostname, CheckMysql.threads, CheckMysql.maxconns, percent_used)),
    sys.exit(2)
